## kio-extras 23.08.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Applications Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "23")
set (RELEASE_SERVICE_VERSION_MINOR "08")
set (RELEASE_SERVICE_VERSION_MICRO "5")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})

set(QT_MIN_VERSION "5.15.2")
set(KF_MIN_VERSION "5.101.0")

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ECM_MODULE_PATH})

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMMarkNonGuiExecutable)
include(ECMMarkAsTest)
include(ECMOptionalAddSubdirectory)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(CheckIncludeFile)
include(CMakePushCheckState)
include(CMakePackageConfigHelpers)
include(FeatureSummary)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS DBus Network Widgets Svg)
if (QT_MAJOR_VERSION EQUAL "6")
    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED Core5Compat)
endif()

find_package(Qt${QT_MAJOR_VERSION}Test ${QT_MIN_VERSION} CONFIG QUIET)
set_package_properties(Qt${QT_MAJOR_VERSION}Test PROPERTIES
         PURPOSE "Required for tests"
         TYPE OPTIONAL
         )
add_feature_info("Qt${QT_MAJOR_VERSION}Test" Qt${QT_MAJOR_VERSION}Test_FOUND "Required for building tests")
if (NOT Qt${QT_MAJOR_VERSION}Test_FOUND)
    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
endif()

find_package(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Config
    ConfigWidgets
    CoreAddons
    DBusAddons
    DocTools
    DNSSD
    I18n
    KIO
    Solid
    Bookmarks
    GuiAddons
    SyntaxHighlighting
)

include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

find_package(KF${QT_MAJOR_VERSION}Activities QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}Activities PROPERTIES
    PURPOSE "Provides the activities:/ KIO worker and fileitem plugin."
    TYPE OPTIONAL
)

find_package(Qt${QT_MAJOR_VERSION}Sql QUIET)
set_package_properties(Qt${QT_MAJOR_VERSION}Sql PROPERTIES
    PURPOSE "Provides the activities:/ KIO worker and fileitem plugin."
    TYPE OPTIONAL
)

find_package(KF${QT_MAJOR_VERSION}ActivitiesStats ${KF_MIN_VERSION} QUIET)
set_package_properties(KF${QT_MAJOR_VERSION}ActivitiesStats PROPERTIES
    PURPOSE "Provides the recentlyused:/ KIO worker"
    TYPE OPTIONAL
)

find_package(Phonon4Qt${QT_MAJOR_VERSION} 4.6.60 NO_MODULE)
set_package_properties(Phonon4Qt${QT_MAJOR_VERSION} PROPERTIES
   DESCRIPTION "Qt-based audio library"
   PURPOSE "Required for the audio preview plugin"
   TYPE OPTIONAL)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(NOT WIN32)
    # we need a version of samba which has already smbc_set_context(), Alex
    set(SAMBA_REQUIRE_SMBC_SET_CONTEXT TRUE)
    set(SAMBA_REQUIRE_SMBC_OPTION_SET TRUE)
    find_package(Samba)
    set_package_properties(Samba PROPERTIES DESCRIPTION "the SMB client library, a version with smbc_set_context() and smbc_option_set()"
                        URL "https://www.samba.org/"
                        TYPE OPTIONAL
                        PURPOSE "Needed to build the SMB KIO worker"
                        )
endif()

find_package(libssh 0.8.3 MODULE)
set_package_properties(libssh PROPERTIES DESCRIPTION "the SSH library with SFTP support"
                       URL "https://www.libssh.org/"
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the SFTP KIO worker"
                      )

find_package(Libmtp 1.1.2)
set_package_properties(Libmtp PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the MTP KIO worker"
                       )

find_package(IMobileDevice)
set_package_properties(IMobileDevice PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the AFC (Apple File Conduit) KIO worker"
                      )

find_package(PList)
set_package_properties(PList PROPERTIES
                       TYPE OPTIONAL
                       PURPOSE "Needed to build the AFC (Apple File Conduit) KIO worker"
                      )

check_include_file(utime.h HAVE_UTIME_H)

# ECM's KDECompilerSettings.cmake should take care of enabling supporting on
# 32bit architectures.
# Thorw a fatal error if off_t isn't >=64bit to ensure that large files are working
# as expected.
# BUG: 165449
if(UNIX)
    check_cxx_source_compiles("
        #include <sys/types.h>
        /* Check that off_t can represent 2**63 - 1 correctly.
            We can't simply define LARGE_OFF_T to be 9223372036854775807,
            since some C++ compilers masquerading as C compilers
            incorrectly reject 9223372036854775807.  */
        #define LARGE_OFF_T (((off_t) 1 << 62) - 1 + ((off_t) 1 << 62))

        int off_t_is_large[(LARGE_OFF_T % 2147483629 == 721 && LARGE_OFF_T % 2147483647 == 1) ? 1 : -1];
        int main() { return 0; }
    "
    OFFT_IS_64BIT)

    if(NOT OFFT_IS_64BIT)
        message(FATAL_ERROR "Large file support is not enabled.")
    endif()

    find_package(Gperf)
    set_package_properties(Gperf PROPERTIES TYPE OPTIONAL
                           PURPOSE "Needed to build the man KIO worker"
                           )

    find_package(TIRPC)
    set_package_properties(TIRPC PROPERTIES TYPE OPTIONAL
                           PURPOSE "Needed to build the NFS KIO worker"
                           )
else()
    # FIXME: on windows we ignore support until trash gets integrated
endif()

ecm_set_disabled_deprecation_versions(
    QT 5.15.2
    KF 5.96
)

add_subdirectory( doc )

if(TARGET KF${QT_MAJOR_VERSION}::Activities AND TARGET Qt::Sql AND NOT WIN32)
  add_subdirectory( activities )
endif()
if(KF${QT_MAJOR_VERSION}ActivitiesStats_FOUND)
    add_subdirectory( recentlyused )
endif()
add_subdirectory( bookmarks )
add_subdirectory( filter )
if(Phonon4Qt${QT_MAJOR_VERSION}_FOUND)
    add_subdirectory( kfileaudiopreview )
endif()
add_subdirectory( info )
add_subdirectory( archive )
add_subdirectory( recentdocuments )
if (NOT WIN32)
    # does not compile: fish.cpp(41): fatal error C1083: Cannot open include file: 'sys/resource.h': No such file or directory
    # Used for getting the resource limit for closing all child process FDs. Could be completely replaced by fcloseall() if available for Unix or _fcloseall() for Windows, either conditionally on Q_OS_type or using a configure test.
    add_subdirectory( fish )
endif()
add_subdirectory( thumbnail )
add_subdirectory( docfilter )
if (libssh_FOUND)
    add_subdirectory(sftp)
endif ()
add_subdirectory( filenamesearch )
if (Libmtp_FOUND)
  add_subdirectory(mtp)
endif()

if(NOT WIN32)
   if(Gperf_FOUND)
     add_subdirectory( man )
   endif()
   if(TIRPC_FOUND)
     add_subdirectory( nfs )
   endif()
endif()

if(SAMBA_FOUND)
    add_subdirectory(smb)
endif()

if(IMobileDevice_FOUND AND PList_FOUND)
    add_subdirectory(afc)
endif()

configure_file (config-runtime.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-runtime.h )

ecm_qt_install_logging_categories(
    EXPORT KIO_EXTRAS
    FILE kio-extras.categories
    DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}"
)

ki18n_install(po)
kdoctools_install(po)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== archive/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio5_archive\")

if(BUILD_TESTING)
    add_subdirectory(autotests)
endif()

set(LIBKIOARCHIVE_VERSION "5.98.0")
set(LIBKIOARCHIVE_SOVERSION "5")
set(LIBKIOARCHIVE_INSTALL_INCLUDEDIR "${KDE_INSTALL_INCLUDEDIR}/KioArchive")

include(ECMSetupVersion)
ecm_setup_version(${LIBKIOARCHIVE_VERSION} VARIABLE_PREFIX "KIOARCHIVE"
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kioarchive_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KioArchiveConfigVersion.cmake"
                  SOVERSION ${LIBKIOARCHIVE_SOVERSION})

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KioArchive")

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/KioArchiveConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/KioArchiveConfig.cmake"
  INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

install(FILES
  "${CMAKE_CURRENT_BINARY_DIR}/KioArchiveConfig.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/KioArchiveConfigVersion.cmake"
  DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
  COMPONENT Devel
)

install(EXPORT KioArchiveTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE KioArchiveTargets.cmake
)

install(FILES
    kio_archivebase.h
    ${CMAKE_CURRENT_BINARY_DIR}/libkioarchive_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/kioarchive_version.h
    DESTINATION ${LIBKIOARCHIVE_INSTALL_INCLUDEDIR}
    COMPONENT Devel
)

ecm_qt_declare_logging_category(kio_archive_debug_SRCS
    HEADER kio_archive_debug.h
    IDENTIFIER KIO_ARCHIVE_LOG
    CATEGORY_NAME kf.kio.workers.archive
    OLD_CATEGORY_NAMES log_kio_archive kf.kio.slaves.archive
    DESCRIPTION "KIO archive"
    EXPORT KIO_EXTRAS
)

############### ArchiveProtocolBase library ###########

add_library(kioarchive kio_archivebase.cpp ${kio_archive_debug_SRCS})

include(GenerateExportHeader)
generate_export_header(kioarchive BASE_NAME libkioarchive EXPORT_FILE_NAME libkioarchive_export.h)

target_compile_definitions(kioarchive
    PRIVATE
        -DKIOCORE_DISABLE_DEPRECATED_BEFORE_AND_AT=0x054400 # need to support KIO::detailsToStatDetails
)

target_link_libraries(kioarchive
    PUBLIC
    KF${QT_MAJOR_VERSION}::Archive
    KF${QT_MAJOR_VERSION}::KIOCore
    PRIVATE
    KF${QT_MAJOR_VERSION}::I18n
    Qt::Network
    Qt::DBus
)

set_target_properties(kioarchive PROPERTIES
    VERSION ${KIOARCHIVE_VERSION}
    SOVERSION ${KIOARCHIVE_SOVERSION}
    EXPORT_NAME KioArchive
)

target_include_directories(kioarchive
    INTERFACE "$<INSTALL_INTERFACE:${LIBKIOARCHIVE_INSTALL_INCLUDEDIR}>"
)

install(TARGETS kioarchive EXPORT KioArchiveTargets LIBRARY NAMELINK_SKIP ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

############### Archive Worker ######################

add_library(kio_archive MODULE kio_archive.cpp ${kio_archive_debug_SRCS})
target_link_libraries(kio_archive KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::Archive kioarchive Qt::Network)
set_target_properties(kio_archive PROPERTIES OUTPUT_NAME "archive")
install(TARGETS kio_archive DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)

=== filenamesearch/CMakeLists.txt ===
kcoreaddons_add_plugin(kio_filenamesearch INSTALL_NAMESPACE "kf${QT_MAJOR_VERSION}/kio")

target_link_libraries(kio_filenamesearch KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::DBusAddons Qt::Network KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::I18n)
target_sources(kio_filenamesearch PRIVATE kio_filenamesearch.cpp)

ecm_qt_declare_logging_category(kio_filenamesearch
    HEADER kio_filenamesearch_debug.h
    IDENTIFIER KIO_FILENAMESEARCH
    CATEGORY_NAME kf.kio.workers.filenamesearch
    OLD_CATEGORY_NAMES kio_filenamesearch kf.kio.slaves.filenamesearch
    DESCRIPTION "KIO filenamesearch"
    EXPORT KIO_EXTRAS
)

add_subdirectory(kded)

=== filter/CMakeLists.txt ===
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

add_library(kio_filter MODULE)
set_target_properties(kio_filter PROPERTIES
    OUTPUT_NAME "filter"
)

target_sources(kio_filter PRIVATE filter.cpp)

ecm_qt_declare_logging_category(kio_filter
    HEADER loggingcategory.h
    IDENTIFIER KIO_FILTER_DEBUG
    CATEGORY_NAME kf.kio.workers.filter
    OLD_CATEGORY_NAMES kio_filter kf.kio.slaves.filter
    DEFAULT_SEVERITY Debug
    DESCRIPTION "KIO filter"
    EXPORT KIO_EXTRAS
)

target_link_libraries(kio_filter KF${QT_MAJOR_VERSION}::Archive KF${QT_MAJOR_VERSION}::KIOCore Qt::Network)

install(TARGETS kio_filter DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)

=== fish/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio5_fish\")

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

include(CheckIncludeFiles)
include(CheckFunctionExists)

check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(util.h HAVE_UTIL_H)
check_include_files(sys/ioctl.h HAVE_SYS_IOCTL_H)
check_include_files(pty.h HAVE_PTY_H)
check_include_files("sys/types.h;libutil.h" HAVE_LIBUTIL_H)
check_function_exists(getpt       HAVE_GETPT)
check_function_exists(grantpt     HAVE_GRANTPT)
include(CheckLibraryExists)
check_library_exists(util  openpty "" HAVE_OPENPTY)
check_library_exists(util  isastream "" HAVE_ISASTREAM)

find_library(UTIL_LIBRARIES util)
mark_as_advanced(UTIL_LIBRARIES)

configure_file(config-fish.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-fish.h)

########### next target ###############
# on Linux there is md5sum, on FreeBSD there is md5
find_program(MD5SUM_EXECUTABLE NAMES md5sum md5 )
    
if (MD5SUM_EXECUTABLE)

   add_library(kio_fish MODULE)
   set_target_properties(kio_fish PROPERTIES
      OUTPUT_NAME "fish"
   )

   if ("${MD5SUM_EXECUTABLE}" MATCHES "md5sum")
      set(CUT_ARG "-f 1")                            # for md5sum the sum is in the 1st column
   else ()
      set(CUT_ARG "-f 4")                            # for md5 the sum is in the 4th column
   endif ()

   if (WIN32)
      set(FISH_GENERATOR "generate_fishcode.bat")
   else ()
      set(FISH_GENERATOR "generate_fishcode.sh")
   endif ()
   set(fishcode_HDR "${CMAKE_CURRENT_BINARY_DIR}/fishcode.h")
   add_custom_command(OUTPUT ${fishcode_HDR}
      COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/${FISH_GENERATOR} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/fish.pl ${MD5SUM_EXECUTABLE} ${fishcode_HDR} "${CUT_ARG}"
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/fish.pl
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} )
   set_source_files_properties(${fishcode_HDR} PROPERTIES SKIP_AUTOMOC TRUE)

   target_sources(kio_fish PRIVATE
      fish.cpp
      ${fishcode_HDR}
   )

   ecm_qt_declare_logging_category(kio_fish
      HEADER loggingcategory.h
      IDENTIFIER KIO_FISH_DEBUG
      CATEGORY_NAME kf.kio.workers.fish
      OLD_CATEGORY_NAMES kio_fish kf.kio.slaves.fish
      DEFAULT_SEVERITY Info
      DESCRIPTION "KIO fish"
      EXPORT KIO_EXTRAS
   )

   target_link_libraries(kio_fish KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::WidgetsAddons KF${QT_MAJOR_VERSION}::I18n Qt::Network)

   if (UTIL_LIBRARIES)
      target_link_libraries(kio_fish ${UTIL_LIBRARIES})
   endif ()

   install(TARGETS kio_fish  DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio )

endif ()

=== kfileaudiopreview/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kfileaudiopreview5\")

add_library(kfileaudiopreview MODULE)

target_sources(kfileaudiopreview PRIVATE
   kfileaudiopreview.cpp
   mediacontrols.cpp
)

target_include_directories(kfileaudiopreview SYSTEM PRIVATE ${PHONON_INCLUDE_DIR})

target_link_libraries(kfileaudiopreview
   ${PHONON_LIBRARIES}
   KF${QT_MAJOR_VERSION}::KIOFileWidgets    # KPreviewWidgetBase
   KF${QT_MAJOR_VERSION}::I18n
)

install(TARGETS kfileaudiopreview
        DESTINATION ${KDE_INSTALL_PLUGINDIR})

=== man/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio5_man\")

remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
)

find_package(KF${QT_MAJOR_VERSION} REQUIRED COMPONENTS Codecs)

# silence warnings for gperf generating code with 0 for null pointers
set(AVOID_NULLPTR_WARNING_FLAG)
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(_flag "-Wno-zero-as-null-pointer-constant")
    check_cxx_compiler_flag(${_flag} _flag_present)
    if(_flag_present)
        set(AVOID_NULLPTR_WARNING_FLAG ${_flag})
    endif()
endif()

if(BUILD_TESTING)
    add_subdirectory( tests )
endif()

# intermediate target/library, also used by the tests
add_library(kio_man_debug OBJECT)
target_link_libraries(kio_man_debug
    PRIVATE Qt::Core
)
ecm_qt_declare_logging_category(kio_man_debug
    HEADER kio_man_debug.h
    IDENTIFIER KIO_MAN_LOG
    CATEGORY_NAME kf.kio.workers.man
    OLD_CATEGORY_NAMES log_kio_man kf.kio.slaves.man
    DESCRIPTION "KIO man"
    EXPORT KIO_EXTRAS
)

set_property(TARGET kio_man_debug PROPERTY POSITION_INDEPENDENT_CODE ON)

########### next target ###############

add_library(kio_man MODULE)
set_target_properties(kio_man PROPERTIES
    OUTPUT_NAME "man"
)

set(kio_man_generated_SRCS)
ecm_gperf_generate(requests.gperf ${CMAKE_CURRENT_BINARY_DIR}/request_gperf.h kio_man_generated_SRCS)
target_sources(kio_man PRIVATE
    ${kio_man_generated_SRCS}
    man2html.cpp
    kio_man.cpp
    request_hash.cpp
)

if (AVOID_NULLPTR_WARNING_FLAG)
    target_compile_options(kio_man PRIVATE ${AVOID_NULLPTR_WARNING_FLAG})
endif()

target_link_libraries(kio_man
    PRIVATE KF${QT_MAJOR_VERSION}::KIOCore Qt::Widgets KF${QT_MAJOR_VERSION}::Archive KF${QT_MAJOR_VERSION}::I18n KF${QT_MAJOR_VERSION}::Codecs Qt::Network kio_man_debug
)

if (QT_MAJOR_VERSION STREQUAL "6")
    target_link_libraries(kio_man PRIVATE Qt::Core5Compat)
endif()

install(TARGETS kio_man DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)

=== nfs/CMakeLists.txt ===
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

## Check for XDR functions
include(CheckCXXSymbolExists)

set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${TIRPC_LIBRARIES})
set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${TIRPC_INCLUDE_DIRS})
check_cxx_symbol_exists(xdr_u_int64_t "rpc/xdr.h" HAVE_XDR_U_INT64_T)
check_cxx_symbol_exists(xdr_uint64_t "rpc/xdr.h" HAVE_XDR_UINT64_T)
check_cxx_symbol_exists(xdr_u_hyper "rpc/xdr.h" HAVE_XDR_U_HYPER)
check_cxx_symbol_exists(xdr_u_longlong_t "rpc/xdr.h" HAVE_XDR_U_LONGLONG_T)

if (NOT HAVE_XDR_U_INT64_T AND NOT HAVE_XDR_UINT64_T AND NOT HAVE_XDR_U_HYPER AND NOT HAVE_XDR_U_LONGLONG_T)
    message(FATAL_ERROR "Could not find 64-bit XDR datatype functions!")
endif (NOT HAVE_XDR_U_INT64_T AND NOT HAVE_XDR_UINT64_T AND NOT HAVE_XDR_U_HYPER AND NOT HAVE_XDR_U_LONGLONG_T)

if (HAVE_XDR_U_INT64_T)
    add_definitions(-DHAVE_XDR_U_INT64_T)
endif (HAVE_XDR_U_INT64_T)
if (HAVE_XDR_UINT64_T)
    add_definitions(-DHAVE_XDR_UINT64_T)
endif (HAVE_XDR_UINT64_T)
if (HAVE_XDR_U_HYPER)
    add_definitions(-DHAVE_XDR_U_HYPER)
endif (HAVE_XDR_U_HYPER)
if (HAVE_XDR_U_LONGLONG_T)
    add_definitions(-DHAVE_XDR_U_LONGLONG_T)
endif (HAVE_XDR_U_LONGLONG_T)

# silence warnings for rpcgen generated code having lots of unused variables
set(AVOID_UNUSED_VARIABLE_WARNING_FLAG)
if (CMAKE_C_COMPILER_ID STREQUAL "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    set(_flag "-Wno-unused-variable")
    check_c_compiler_flag(${_flag} _flag_present)
    if(_flag_present)
        set(AVOID_UNUSED_VARIABLE_WARNING_FLAG ${_flag})
    endif()
endif()

# silence warnings for use of xdr_void as no-op method in calls of clnt_call()
# It's method signature "bool_t xdr_void(void)" does not match the xdrproc_t definition
# which is "bool_t (*)(XDR*, ...)", and the compiler correctly points that out as issue.
# While no-one has come up so far with a nice way to tell the compiler that cast is fine,
# for now just disable the warning completely for the compilation unit.
set(AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG)
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(_flag "-Wno-cast-function-type")
    check_cxx_compiler_flag(${_flag} _flag_present)
    if(_flag_present)
        set(AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG ${_flag})
    endif()
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"kio5_nfs\")
include_directories(${TIRPC_INCLUDE_DIRS})

add_library(kio_nfs MODULE kio_nfs.cpp nfsv2.cpp nfsv3.cpp rpc_nfs3_prot_xdr.c rpc_nfs2_prot_xdr.c)
target_link_libraries(kio_nfs KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::ConfigCore KF${QT_MAJOR_VERSION}::I18n Qt::Network ${TIRPC_LIBRARIES})
set_target_properties(kio_nfs PROPERTIES OUTPUT_NAME "nfs")

if(AVOID_UNUSED_VARIABLE_WARNING_FLAG)
    set_source_files_properties(rpc_nfs2_prot_xdr.c rpc_nfs3_prot_xdr.c PROPERTIES
        COMPILE_OPTIONS "${AVOID_UNUSED_VARIABLE_WARNING_FLAG}"
    )
endif()

if(AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG)
    set_source_files_properties(nfsv2.cpp nfsv3.cpp PROPERTIES
        COMPILE_OPTIONS "${AVOID_CAST_FUNCTION_TYPE_WARNING_FLAG}"
    )
endif()

ecm_qt_declare_logging_category(kio_nfs
    HEADER kio_nfs_debug.h
    IDENTIFIER LOG_KIO_NFS
    CATEGORY_NAME kf.kio.workers.nfs
    OLD_CATEGORY_NAMES kde.kio_nfs kf.kio.slaves.nfs
    DESCRIPTION "KIO nfs"
    EXPORT KIO_EXTRAS
)

install(TARGETS kio_nfs DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)

########### install files ###############

=== recentdocuments/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio5_recentdocuments\")

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

add_library(kio_recentdocuments MODULE recentdocuments.cpp)
ecm_qt_declare_logging_category(kio_recentdocuments
    HEADER recentdocuemnts_log.h
    IDENTIFIER LOG_RECENTDOCUMENTS
    CATEGORY_NAME kf.kio.workers.recentdocuments
    OLD_CATEGORY_NAMES kf.kio.slaves.recentdocuments
    DESCRIPTION "KIO recentdocuments"
    EXPORT KIO_EXTRAS
)
target_link_libraries(kio_recentdocuments KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::I18n KF${QT_MAJOR_VERSION}::ConfigCore Qt::DBus Qt::Network)
set_target_properties(kio_recentdocuments PROPERTIES OUTPUT_NAME "recentdocuments")
install(TARGETS kio_recentdocuments DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)

########### next target ###############

add_library(kded_recentdocumentsnotifier MODULE recentdocumentsnotifier.cpp)
set_target_properties(kded_recentdocumentsnotifier PROPERTIES OUTPUT_NAME recentdocumentsnotifier)

target_link_libraries(kded_recentdocumentsnotifier KF${QT_MAJOR_VERSION}::KIOCore KF${QT_MAJOR_VERSION}::DBusAddons)

install(TARGETS kded_recentdocumentsnotifier  DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kded )

########### install files ###############

=== recentlyused/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio5_recentlyused\")

add_library(recentlyused MODULE)
set_target_properties(recentlyused PROPERTIES
    OUTPUT_NAME "recentlyused"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf${QT_MAJOR_VERSION}/kio"
)
target_sources(recentlyused PRIVATE
    recentlyused.cpp
)
# recentlyused.h has examples in the comment secions which match /*,
# so triggering the preprocessor to warn about nested comments.
# Using a pragma to ignore that diagnostic does not work for preprocessor warnings
# so for now simply that warning is completly disabled
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    set(_flag "-Wno-comment")
    check_cxx_compiler_flag(${_flag} _flag_present)
    if(_flag_present)
        target_compile_options(recentlyused PRIVATE "${_flag}")
    endif()
endif()

ecm_qt_declare_logging_category(recentlyused
    HEADER recentlyused-logsettings.h
    IDENTIFIER KIO_RECENTLYUSED_LOG
    CATEGORY_NAME kf.kio.workers.recentlyused
    OLD_CATEGORY_NAMES log_kio_recentlyused kf.kio.slaves.recentlyused
    DESCRIPTION "KIO recentlyused"
    EXPORT KIO_EXTRAS
)

target_link_libraries(recentlyused
    KF${QT_MAJOR_VERSION}::KIOCore
    KF${QT_MAJOR_VERSION}::I18n
    KF${QT_MAJOR_VERSION}::Activities
    KF${QT_MAJOR_VERSION}::ActivitiesStats)

install(TARGETS recentlyused DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)

# forgetfileitemaction plugin
kcoreaddons_add_plugin(forgetfileitemaction
    SOURCES forgetfileitemaction.cpp
    INSTALL_NAMESPACE "kf${QT_MAJOR_VERSION}/kfileitemaction")

target_link_libraries(forgetfileitemaction
    KF${QT_MAJOR_VERSION}::I18n
    KF${QT_MAJOR_VERSION}::KIOWidgets)

=== sftp/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kio5_sftp\")

remove_definitions(-DQT_NO_CAST_FROM_ASCII)

add_library(kio_sftp MODULE)
set_target_properties(kio_sftp PROPERTIES
    OUTPUT_NAME "sftp"
    LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf${QT_MAJOR_VERSION}/kio"
)

target_sources(kio_sftp PRIVATE kio_sftp.cpp)

ecm_qt_declare_logging_category(kio_sftp
    HEADER kio_sftp_debug.h
    IDENTIFIER KIO_SFTP_LOG
    CATEGORY_NAME kf.kio.workers.sftp
    OLD_CATEGORY_NAMES log_kio_sftp kf.kio.slaves.sftp
    DESCRIPTION "KIO sftp"
    EXPORT KIO_EXTRAS
)

ecm_qt_declare_logging_category(kio_sftp
    HEADER kio_sftp_trace_debug.h
    IDENTIFIER KIO_SFTP_TRACE_LOG
    CATEGORY_NAME kf.kio.workers.sftp.trace
    OLD_CATEGORY_NAMES log_kio_sftp.trace kf.kio.slaves.sftp.trace
    DESCRIPTION "KIO sftp (trace)"
    EXPORT KIO_EXTRAS
)

if(WIN32)
    target_include_directories(kio_sftp PRIVATE ${QT_MKSPECS_DIR}/default) # for SYMLINKS
endif()

target_link_libraries(kio_sftp
   KF${QT_MAJOR_VERSION}::KIOCore
   KF${QT_MAJOR_VERSION}::WidgetsAddons # KMessageBox
   KF${QT_MAJOR_VERSION}::ConfigCore
   KF${QT_MAJOR_VERSION}::I18n
   Qt::Network
   ssh)

install(TARGETS kio_sftp DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)

=== smb/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    # KDSoapWSDiscoveryClient uses "signals" and "slots" in public headers
    # so remove definition both for internal copy as well as smb code
    -DQT_NO_KEYWORDS
)

option(BUILD_KDSoapWSDiscoveryClient "Automatically build WSD client if a system one isn't found." ON)
find_package(KDSoapWSDiscoveryClient QUIET)
set(INTERNAL_WSDCLIENT ${BUILD_KDSoapWSDiscoveryClient})
if(KDSoapWSDiscoveryClient_FOUND)
    set(INTERNAL_WSDCLIENT OFF)
endif()
if(INTERNAL_WSDCLIENT)
    # Special internal version, mangled to be a STATIC lib.
    # This is only useful and necessary until the library has
    # its API finalized and gotten a stable release.
    # Until then when using it as external library you should try
    # to use a snapshot that matches the internal copy's git ref.
    # Currently at: dcefb65c88e76f1f9eda8b0318006e93d15a0e1e
    add_subdirectory(kdsoap-ws-discovery-client)
endif()
add_feature_info("Internal KDSoapWSDiscoveryClient" INTERNAL_WSDCLIENT
    "Building using internal client because a system-provided version could not be found.")

find_package(Threads REQUIRED)

add_definitions(-DTRANSLATION_DOMAIN=\"kio5_smb\")

include(CheckIncludeFile)
include(CheckSymbolExists)
set(CMAKE_AUTOMAKE ON)

cmake_push_check_state()
list(APPEND CMAKE_REQUIRED_INCLUDES ${SAMBA_INCLUDE_DIR})
list(APPEND CMAKE_REQUIRED_LIBRARIES ${SAMBA_LIBRARIES})
check_symbol_exists(smbc_readdirplus2 "libsmbclient.h" HAVE_READDIRPLUS2)
cmake_pop_check_state()
check_include_file(utime.h HAVE_UTIME_H)

configure_file(config-smb.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-smb.h)

# Intermediate static lib target for reuse in testing.
add_library(kio_smb_static STATIC)

target_sources(kio_smb_static PRIVATE
    kio_smb.cpp
    kio_smb_auth.cpp
    kio_smb_browse.cpp
    kio_smb_config.cpp
    kio_smb_dir.cpp
    kio_smb_file.cpp
    smburl.cpp
    kio_smb_mount.cpp
    wsdiscoverer.cpp
    dnssddiscoverer.cpp
    discovery.cpp
    transfer.cpp
    smbcdiscoverer.cpp
    smbcontext.cpp
    smbauthenticator.cpp
)

ecm_qt_declare_logging_category(kio_smb_static
    HEADER smb-logsettings.h
    IDENTIFIER KIO_SMB_LOG
    CATEGORY_NAME kf.kio.workers.smb
    OLD_CATEGORY_NAMES log_kio_smb kf.kio.slaves.smb
    DESCRIPTION "KIO smb"
    EXPORT KIO_EXTRAS
)

set_property(TARGET kio_smb_static PROPERTY POSITION_INDEPENDENT_CODE ON)

include_directories(${SAMBA_INCLUDE_DIR})

target_include_directories(kio_smb_static
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_BINARY_DIR};${CMAKE_CURRENT_SOURCE_DIR}/..;${CMAKE_CURRENT_BINARY_DIR}/..>"
)
target_link_libraries(kio_smb_static
    KF${QT_MAJOR_VERSION}::KIOCore
    KF${QT_MAJOR_VERSION}::I18n
    KF${QT_MAJOR_VERSION}::ConfigCore
    ${SAMBA_LIBRARIES}
    Qt::Network
    KF${QT_MAJOR_VERSION}::DNSSD
    KDSoap::WSDiscoveryClient
    Threads::Threads # std::async
)
if (QT_MAJOR_VERSION EQUAL "6")
    target_link_libraries(kio_smb_static Qt6::Core5Compat)
endif()

# Final plugin target.
add_library(kio_smb MODULE main.cpp)
target_link_libraries(kio_smb
    kio_smb_static
)

set_target_properties(kio_smb PROPERTIES OUTPUT_NAME "smb")
set_target_properties(kio_smb PROPERTIES LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin/kf${QT_MAJOR_VERSION}/kio")

install(TARGETS kio_smb DESTINATION ${KDE_INSTALL_PLUGINDIR}/kf${QT_MAJOR_VERSION}/kio)
install(FILES smb-network.desktop DESTINATION ${KDE_INSTALL_DATADIR}/konqueror/dirtree/remote)
install(FILES smb-network.desktop DESTINATION ${KDE_INSTALL_DATADIR}/remoteview)

option(WITH_SHAREDMIMEINFO "Build with shared shared-mime-info and update mimetype database on install" ON)
if(WITH_SHAREDMIMEINFO)
    install(FILES org.kde.kio.smb.xml DESTINATION ${KDE_INSTALL_MIMEDIR})
    find_package(SharedMimeInfo 1.3)
    set_package_properties(SharedMimeInfo PROPERTIES
        TYPE REQUIRED
        PURPOSE "Used to update the mimetype database")
    update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})
endif()

add_subdirectory(autotests)
add_subdirectory(kded)

=== debian/changelog ===
kio-extras (4:23.08.5-0ubuntu5) noble; urgency=medium

  * No-change rebuild against libplist-2.0-4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 05 Apr 2024 08:05:41 +0000

kio-extras (4:23.08.5-0ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 09:06:10 +0000

kio-extras (4:23.08.5-0ubuntu3) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 05:02:02 +0000

kio-extras (4:23.08.5-0ubuntu2) noble; urgency=medium

  * No-change rebuild against libtirpc3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 09:25:14 +0000

kio-extras (4:23.08.5-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.5)

 -- Scarlett Moore <sgmoore@debian.org>  Thu, 22 Feb 2024 10:01:04 -0700

=== debian/control ===
Source: kio-extras
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf5,
               extra-cmake-modules (>= 5.101.0~),
               gettext,
               gperf,
               kio,
               libappimage-dev (>= 0.1.10~) [linux-any],
               libimobiledevice-dev,
               libkdsoap-dev (>= 1.9.0~),
               libkf5activities-dev (>= 5.101.0~),
               libkf5activitiesstats-dev (>= 5.101.0~),
               libkf5archive-dev (>= 5.101.0~),
               libkf5bookmarks-dev (>= 5.101.0~),
               libkf5config-dev (>= 5.101.0~),
               libkf5configwidgets-dev (>= 5.101.0~),
               libkf5coreaddons-dev (>= 5.101.0~),
               libkf5dbusaddons-dev (>= 5.101.0~),
               libkf5dnssd-dev (>= 5.101.0~),
               libkf5doctools-dev (>= 5.101.0~),
               libkf5guiaddons-dev (>= 5.101.0~),
               libkf5i18n-dev (>= 5.101.0~),
               libkf5kexiv2-dev (>= 23.08.5~),
               libkf5kio-dev (>= 5.101.0~),
               libkf5solid-dev (>= 5.101.0~),
               libkf5syntaxhighlighting-dev (>= 5.101.0~),
               libmtp-dev (>= 1.1.2~),
               libopenexr-dev (>= 3.0~),
               libphonon4qt5-dev (>= 4:4.6.60),
               libplist-dev,
               libqt5svg5-dev (>= 5.15.2~),
               libsmbclient-dev,
               libssh-dev (>= 0.8.3~),
               libtag1-dev (>= 1.11~),
               libtirpc-dev,
               libxcursor-dev,
               pkg-config,
               qtbase5-dev (>= 5.15.2~),
               shared-mime-info (>= 1.3~),
Standards-Version: 4.6.2
Homepage: https://projects.kde.org/projects/kde/workspace/kio-extras
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
Rules-Requires-Root: no

Package: kio-extras
Architecture: any
Depends: kio-extras-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Extra functionality for kioslaves.
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package is part of the KDE base workspace module.

Package: kio-extras-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
Breaks: kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Replaces: kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Description: Extra functionality for kioslaves data files.
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package contains the data files

## kio-extras 24.08.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,14 @@
 cmake_minimum_required(VERSION 3.16)
 
 # KDE Applications Version, managed by release script
-set (RELEASE_SERVICE_VERSION_MAJOR "23")
+set (RELEASE_SERVICE_VERSION_MAJOR "24")
 set (RELEASE_SERVICE_VERSION_MINOR "08")
-set (RELEASE_SERVICE_VERSION_MICRO "5")
+set (RELEASE_SERVICE_VERSION_MICRO "1")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 project(kio-extras VERSION ${RELEASE_SERVICE_VERSION})
 
-set(QT_MIN_VERSION "5.15.2")
-set(KF_MIN_VERSION "5.101.0")
+set(QT_MIN_VERSION "6.5.0")
+set(KF_MIN_VERSION "6.0.0")
 
 find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${ECM_MODULE_PATH})
@@ -19,6 +19,7 @@
 include(KDEInstallDirs)
 include(KDECMakeSettings)
 include(KDECompilerSettings NO_POLICY_SCOPE)
+include(KDEGitCommitHooks)
 
 include(ECMMarkNonGuiExecutable)
 include(ECMMarkAsTest)
@@ -30,61 +31,65 @@
 include(CMakePackageConfigHelpers)
 include(FeatureSummary)
 
-find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS DBus Network Widgets Svg)
-if (QT_MAJOR_VERSION EQUAL "6")
-    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED Core5Compat)
-endif()
-
-find_package(Qt${QT_MAJOR_VERSION}Test ${QT_MIN_VERSION} CONFIG QUIET)
-set_package_properties(Qt${QT_MAJOR_VERSION}Test PROPERTIES
-         PURPOSE "Required for tests"
-         TYPE OPTIONAL
-         )
-add_feature_info("Qt${QT_MAJOR_VERSION}Test" Qt${QT_MAJOR_VERSION}Test_FOUND "Required for building tests")
-if (NOT Qt${QT_MAJOR_VERSION}Test_FOUND)
-    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
-endif()
-
-find_package(KF${QT_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
+find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS Network Widgets Svg Core5Compat)
+
+find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
     Archive
     Config
     ConfigWidgets
     CoreAddons
-    DBusAddons
+
     DocTools
     DNSSD
     I18n
     KIO
     Solid
-    Bookmarks
     GuiAddons
     SyntaxHighlighting
+    KCMUtils
+    TextWidgets
 )
+
+# shall we use DBus?
+# enabled per default on Linux & BSD systems
+set(USE_DBUS_DEFAULT OFF)
+if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
+    set(USE_DBUS_DEFAULT ON)
+endif()
+option(USE_DBUS "Build components using DBus" ${USE_DBUS_DEFAULT})
+if(USE_DBUS)
+    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS DBus)
+    find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS DBusAddons)
+endif()
+
+find_package(Qt6Test ${QT_MIN_VERSION} CONFIG QUIET)
+set_package_properties(Qt6Test PROPERTIES
+         PURPOSE "Required for tests"
+         TYPE OPTIONAL
+         )
+add_feature_info("Qt6Test" Qt6Test_FOUND "Required for building tests")
+if (NOT Qt6Test_FOUND)
+    set(BUILD_TESTING OFF CACHE BOOL "Build the testing tree.")
+endif()
+
+find_package(QCoro6 REQUIRED COMPONENTS Core)
+qcoro_enable_coroutines()
 
 include(KDEClangFormat)
 file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
 kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
 
-find_package(KF${QT_MAJOR_VERSION}Activities QUIET)
-set_package_properties(KF${QT_MAJOR_VERSION}Activities PROPERTIES
-    PURPOSE "Provides the activities:/ KIO worker and fileitem plugin."
-    TYPE OPTIONAL
-)
-
-find_package(Qt${QT_MAJOR_VERSION}Sql QUIET)
-set_package_properties(Qt${QT_MAJOR_VERSION}Sql PROPERTIES
-    PURPOSE "Provides the activities:/ KIO worker and fileitem plugin."
-    TYPE OPTIONAL
-)
-
-find_package(KF${QT_MAJOR_VERSION}ActivitiesStats ${KF_MIN_VERSION} QUIET)
-set_package_properties(KF${QT_MAJOR_VERSION}ActivitiesStats PROPERTIES
-    PURPOSE "Provides the recentlyused:/ KIO worker"
-    TYPE OPTIONAL
-)
-
-find_package(Phonon4Qt${QT_MAJOR_VERSION} 4.6.60 NO_MODULE)
-set_package_properties(Phonon4Qt${QT_MAJOR_VERSION} PROPERTIES
+if (NOT WIN32 AND USE_DBUS)
+    option(BUILD_ACTIVITIES "Build recentlyused:/, activities:/ KIO workers and fileitem plugin." ON)
+    if(BUILD_ACTIVITIES)
+        find_package(Qt6Sql REQUIRED)
+        find_package(PlasmaActivities REQUIRED)
+        find_package(PlasmaActivitiesStats REQUIRED)
+    endif()
+endif()
+
+find_package(Phonon4Qt6 4.6.60 NO_MODULE)
+set_package_properties(Phonon4Qt6 PROPERTIES
    DESCRIPTION "Qt-based audio library"
    PURPOSE "Required for the audio preview plugin"
    TYPE OPTIONAL)
@@ -157,48 +162,43 @@
     set_package_properties(Gperf PROPERTIES TYPE OPTIONAL
                            PURPOSE "Needed to build the man KIO worker"
                            )
-
-    find_package(TIRPC)
-    set_package_properties(TIRPC PROPERTIES TYPE OPTIONAL
-                           PURPOSE "Needed to build the NFS KIO worker"
-                           )
 else()
     # FIXME: on windows we ignore support until trash gets integrated
 endif()
 
 ecm_set_disabled_deprecation_versions(
     QT 5.15.2
-    KF 5.96
+    KF 6.0
 )
 
-add_subdirectory( doc )
-
-if(TARGET KF${QT_MAJOR_VERSION}::Activities AND TARGET Qt::Sql AND NOT WIN32)
+add_subdirectory(doc)
+add_subdirectory(kcms)
+
+if(BUILD_ACTIVITIES)
   add_subdirectory( activities )
-endif()
-if(KF${QT_MAJOR_VERSION}ActivitiesStats_FOUND)
-    add_subdirectory( recentlyused )
-endif()
-add_subdirectory( bookmarks )
+  add_subdirectory( recentlyused )
+endif()
 add_subdirectory( filter )
-if(Phonon4Qt${QT_MAJOR_VERSION}_FOUND)
+if(Phonon4Qt6_FOUND)
     add_subdirectory( kfileaudiopreview )
 endif()
 add_subdirectory( info )
 add_subdirectory( archive )
-add_subdirectory( recentdocuments )
 if (NOT WIN32)
     # does not compile: fish.cpp(41): fatal error C1083: Cannot open include file: 'sys/resource.h': No such file or directory
     # Used for getting the resource limit for closing all child process FDs. Could be completely replaced by fcloseall() if available for Unix or _fcloseall() for Windows, either conditionally on Q_OS_type or using a configure test.
     add_subdirectory( fish )
 endif()
 add_subdirectory( thumbnail )
-add_subdirectory( docfilter )
 if (libssh_FOUND)
     add_subdirectory(sftp)
 endif ()
-add_subdirectory( filenamesearch )
-if (Libmtp_FOUND)
+
+if (NOT WIN32 AND NOT APPLE AND USE_DBUS)
+    add_subdirectory( filenamesearch )
+endif()
+
+if (Libmtp_FOUND AND USE_DBUS)
   add_subdirectory(mtp)
 endif()
 
@@ -206,12 +206,9 @@
    if(Gperf_FOUND)
      add_subdirectory( man )
    endif()
-   if(TIRPC_FOUND)
-     add_subdirectory( nfs )
-   endif()
-endif()
-
-if(SAMBA_FOUND)
+endif()
+
+if(SAMBA_FOUND AND USE_DBUS)
     add_subdirectory(smb)
 endif()
 
@@ -230,4 +227,6 @@
 ki18n_install(po)
 kdoctools_install(po)
 
+kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
+
 feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== debian/changelog ===
kio-extras (4:24.08.1-0ubuntu2) oracular; urgency=medium

  * Restore building smb plugin with kdsoap. (LP: #2080527)

 -- Rik Mills <rikmills@kde.org>  Mon, 16 Sep 2024 16:37:40 +0100

kio-extras (4:24.08.1-0ubuntu1) oracular; urgency=medium

  * New upstream release (24.08.1)

 -- Rik Mills <rikmills@kde.org>  Fri, 13 Sep 2024 06:24:23 +0100

kio-extras (4:24.08.0-1ubuntu1) oracular; urgency=medium

  * Merge debian experimental.

 -- Scarlett Moore <sgmoore@debian.org>  Sat, 07 Sep 2024 01:45:47 -0700

kio-extras (4:24.08.0-1) experimental; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * New upstream release (24.08.0).
  * Update build-deps and deps with the info from cmake.
  * Update list of installed files.
  * Update lintian-overrides.
  * Bump Standards-Version to 4.7.0 (no changes needed).

 -- Patrick Franz <deltaone@debian.org>  Tue, 03 Sep 2024 23:22:47 +0200

kio-extras (4:23.08.4-2) unstable; urgency=medium

  * Team upload.
  * No change upload to manually trigger rebuild with the new
    libimobiledevice and libplist.

 -- Boyuan Yang <byang@debian.org>  Sat, 13 Jul 2024 15:57:51 -0400

=== debian/control ===
Source: kio-extras
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               extra-cmake-modules (>= 6.0.0~),
               gettext,
               gperf,
               libappimage-dev (>= 0.1.10~) [linux-any],
               libimobiledevice-dev,
               libkexiv2qt6-dev,
               libkdsoap-qt6-dev (>= 2.0.0~),
               kdsoap-ws-discovery-client-dev,
               libkf6archive-dev (>= 6.0.0~),
               libkf6config-dev (>= 6.0.0~),
               libkf6configwidgets-dev (>= 6.0.0~),
               libkf6coreaddons-dev (>= 6.0.0~),
               libkf6dbusaddons-dev (>= 6.0.0~),
               libkf6dnssd-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6solid-dev (>= 6.0.0~),
               libkf6syntaxhighlighting-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libmtp-dev (>= 1.1.2~),
               libopenexr-dev (>= 3.0~),
               libphonon4qt6-dev (>= 4:4.6.60~),
               libphonon4qt6experimental-dev (>= 4:4.12.0~),
               libplasmaactivities-dev,
               libplasmaactivitiesstats-dev,
               libplist-dev,
               libsmbclient-dev,
               libssh-dev (>= 0.8.3~),
               libtag1-dev (>= 1.11~),
               libtirpc-dev,
               libxcursor-dev,
               pkgconf,
               qcoro-qt6-dev,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0+dfsg~),
               qt6-svg-dev (>= 6.5.0~),
               shared-mime-info (>= 1.3~),
Standards-Version: 4.7.0
Homepage: https://projects.kde.org/projects/kde/workspace/kio-extras
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kio-extras
Rules-Requires-Root: no

Package: kio-extras
Architecture: any
Depends: kio-extras-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: Extra functionality for kioslaves
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package is part of the KDE base workspace module.

Package: kio-extras-data
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends},
Breaks: kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Replaces: kio-mtp (<< 0.75+git20140304-1ubuntu1~),
Description: Extra functionality for kioslaves data files
 A kioslave is a plugin designed to be intimately familiar with a certain
 protocol, so that a standardized interface can be used to get at data from
 any number of places.  A few examples are the http and ftp kioslaves,
 which using nearly identical methods will retrieve data from an http or
 ftp server respectively.
 .
 This package contains the data files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Skf6 -- -DBUILD_TESTING=OFF

override_dh_auto_test:
	# Tests require a registered logind session. :/
	# If you are reading this, your help is needed to make this work in
	# a reproduceable way either in the buildds or in the autopkgtests
	# servers
	# xvfb-run -a dh_auto_test

execute_after_dh_auto_install:
	# drop development stuff
	rm -rf debian/tmp/usr/include/
	rm -rf debian/tmp/usr/lib/*/cmake/

## kio-extras 24.08.2

=== debian/changelog ===
kio-extras (4:24.08.2-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.08.2)

 -- Rik Mills <rikmills@kde.org>  Sun, 03 Nov 2024 14:40:29 +0000

## kio-extras 24.12.0

=== debian/changelog ===
kio-extras (4:24.12.0-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.12.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 12 Dec 2024 17:12:48 +0000

kio-extras (4:24.11.90-0ubuntu1) plucky; urgency=medium

  * New upstream (RC) release (24.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 29 Nov 2024 14:09:14 +0000

kio-extras (4:24.11.80-0ubuntu1) plucky; urgency=medium

  * New upstream (beta) release (24.11.80)

 -- Rik Mills <rikmills@kde.org>  Tue, 19 Nov 2024 20:49:47 +0000

kio-extras (4:24.08.3-0ubuntu1) plucky; urgency=medium

  * New upstream release (24.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 07 Nov 2024 11:41:29 +0000

=== debian/control ===
--- 
+++ 
@@ -11,11 +11,11 @@
                extra-cmake-modules (>= 6.0.0~),
                gettext,
                gperf,
+               kdsoap-ws-discovery-client-dev,
                libappimage-dev (>= 0.1.10~) [linux-any],
                libimobiledevice-dev,
-               libkexiv2qt6-dev,
                libkdsoap-qt6-dev (>= 2.0.0~),
-               kdsoap-ws-discovery-client-dev,
+               libkexiv2qt6-dev (>= 24.12.0~),
                libkf6archive-dev (>= 6.0.0~),
                libkf6config-dev (>= 6.0.0~),
                libkf6configwidgets-dev (>= 6.0.0~),
